package net.sourceforge.jFuzzyLogic.demo.IP;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import net.sourceforge.jFuzzyLogic.demo.FuzzyDemo;

/**
 *
 * @author pjl
 */
public class IPDemo extends FuzzyDemo {

	private double angle;
	private double startingX;

	@Override
	protected void addControlsImpl(JPanel cntrl) {
		cntrl.add(new JButton(new AbstractAction("RESET") {

			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public void actionPerformed(ActionEvent e) {
				//    ((HumanForceController) humanController).getSlider().setValue(0);
				((IPModel) model).reset();
				((IPModel) model).setX(startingX);
				//       ((IPModel) model).setPhiInDegrees(0.0);
				view.reset();
				view.modelStateChanged();

			}
		}));

	}

	@Override
	protected void addFuzzyControls(JPanel cntrl) {
		JPanel sp = new JPanel();
		sp.add(new JLabel("Angle:"));
		final JSlider smA = new JSlider(-45, 45);
		smA.setMinorTickSpacing(1);
		//     final SpinnerNumberModel smA = new SpinnerNumberModel((int) angle, -180, 180, 1);
		smA.addChangeListener(new ChangeListener() {

			public void stateChanged(ChangeEvent e) {
				angle = smA.getValue();
				((IPFuzzyController2) fuzzyController).setTargetAngle(angle);
			}
		});
		sp.add(smA);

		cntrl.add(sp);

	}

	@Override
	public void initModelImpl() {
		angle = 0.01;
		startingX = -1.0;
		fclFile = new File("fcl/ip2.fcl");
		model = new IPModel();
		view = new IPView();

		//     humanController = new HumanForceController((ForceDrivenModel) model);
		fuzzyController = new IPFuzzyController2((IPModel) model, fclFile);

		((IPModel) model).setX(startingX);

		((IPModel) model).setPhiInDegrees(angle);
		view.setModel(model);
	}
}
