/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sourceforge.jFuzzyLogic.demo.IP;


import java.io.File;
import java.util.List;
import net.sourceforge.jFuzzyLogic.FunctionBlock;
import net.sourceforge.jFuzzyLogic.demo.FuzzyController;
import net.sourceforge.jFuzzyLogic.rule.Variable;

/**
 *
 * @author pjl
 */
public class IPFuzzyController extends FuzzyController{


    private Variable x;
    private Variable dxdt;
    private Variable phi;
    private Variable dphidt;
//    private IPModel model;
    private Variable force;
    private FunctionBlock functionBlock;
    
    public IPFuzzyController(IPModel model, File file) {
        super(file,model);
    }
    
    
    protected void init() {
        if (fis == null) return;
        
        functionBlock = fis.getFunctionBlock(null);
        x = functionBlock.getVariable("x");
        dxdt = functionBlock.getVariable("dxdt");
        phi = functionBlock.getVariable("phi");
        dphidt = functionBlock.getVariable("dphidt");
        force = functionBlock.getVariable("force");
    }



    public void control() {
        if (functionBlock == null) return;

        double X, DXDT, PHI, DPHIDT;
        
        IPModel model=(IPModel)this.model;
        
        x.setValue(X = model.getX());
        dxdt.setValue(DXDT = model.getDxdt());
        phi.setValue(PHI = model.getPhiInDegrees());
        dphidt.setValue(DPHIDT = model.getDPhiDtInDegrees());

        functionBlock.evaluate();

        double dp = force.getLatestDefuzzifiedValue();
        if (Double.isNaN(dp)) {
            dp = 0.0;        //   double dp1=dpull.getValue();
        System.out.println(
                String.format(
                " x=%f  dxdt=%f phi=%f dphidt=%f ",
                 X, DXDT,PHI,DPHIDT));
        }
        model.setForce(dp);

    // Show output variable's chart 
    //	fuzzyRuleSet.getVariable("tip").chartDefuzzifier(true);

    // Print ruleSet
    //	System.out.println(fuzzyRuleSet);
    }

    @Override
    public String showState() {
       // throw new UnsupportedOperationException("Not supported yet.");
        return null;
    }

    @Override
    public List<Variable> getVariables() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
