package net.sourceforge.jFuzzyLogic.demo.block;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Random;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JPanel;
import net.sourceforge.jFuzzyLogic.demo.FuzzyDemo;

 /*
 * @author pjl
 */
public class BlockDemo extends FuzzyDemo {
  
    public void initModelImpl() {
        fclFile = new File("fcl/block.fcl");
        model = new BlockModel();
        view = new BlockView();
        view.setModel(model);
        fuzzyController = new BlockFuzzyController((BlockModel) model, fclFile);
    }

    protected void addControlsImpl(JPanel cntrl) {

        cntrl.add(new JButton(new AbstractAction("ZERO") {
            public void actionPerformed(ActionEvent e) {
                ((BlockModel) model).reset();
            }
        }));
        
        
        cntrl.add(new JButton(new AbstractAction("RANDOM") {           
            final Random rand=new Random();
            public void actionPerformed(ActionEvent e) {
                ((BlockModel) model).reset();                
                ((BlockModel) model).setX((rand.nextDouble() -0.5)*2);
                ((BlockModel) model).setDxdt((rand.nextDouble() -0.5)*2);
            }            
        }));
    }

    @Override
    protected void addFuzzyControls(JPanel cntrl) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
