package net.sourceforge.jFuzzyLogic.demo.block;

import java.io.File;
import java.util.List;
import net.sourceforge.jFuzzyLogic.FunctionBlock;
import net.sourceforge.jFuzzyLogic.demo.FuzzyController;
import net.sourceforge.jFuzzyLogic.rule.Variable;

/**
 *
 * @author pjl
 */
public class BlockFuzzyController extends  FuzzyController{

    private Variable x;
    private Variable dxdt;
    private Variable force;
    private FunctionBlock functionBlock;
    
    public BlockFuzzyController(BlockModel model, File file) {
        super(file,model);
    }
    
    
    protected void init() {
        if ( fis == null) return;
        functionBlock=fis.getFunctionBlock(null);
        x    = functionBlock.getVariable("x");
        dxdt = functionBlock.getVariable("dxdt");
        force = functionBlock.getVariable("force");
    }

    public void control() {
        if (functionBlock == null) return;
        double X, DXDT;

        BlockModel model=(BlockModel)this.model;
        
        x.setValue(X = model.getX());
        dxdt.setValue(DXDT = model.getDxdt());
      

        functionBlock.evaluate();

        double dp = force.getLatestDefuzzifiedValue();
        if (Double.isNaN(dp)) {    
            dp = 0.0;        //   double dp1=dpull.getValue();
            System.out.println("NaN" + X + "  " + "  "+  DXDT + dp);
        }
        model.setForce(dp);

     
    // Show output variable's chart 
    //	fuzzyRuleSet.getVariable("tip").chartDefuzzifier(true);

    // Print ruleSet
    //	System.out.println(fuzzyRuleSet);
    }

    @Override
    public String  showState() {
       String str= "x="+ x.getValue() +  "  dxdt="+    dxdt.getValue() + "\n";
       return str+force.toString();
    }

    @Override
    public List<Variable> getVariables() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
   
    
}
