package net.sourceforge.jFuzzyLogic.demo.block;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.Shape;

import javax.swing.JPanel;

import net.sourceforge.jFuzzyLogic.demo.Model;
import net.sourceforge.jFuzzyLogic.demo.View;

/**
 * IPView provides a view of IPModel
 * @author drew
 */
public final class BlockView extends JPanel implements View {

	// Variables declaration - do not modify
	// End of variables declaration
	//  http://java.sun.com/docs/books/tutorial/uiswing/14painting/practice.html
	
	static int gAy[] = { 10, 0, -10 };
	static int leftAx[] = { 0, -20, 0 };
	static int rightAx[] = { 0, 20, 0 };
	static Shape arrowL = new Polygon(leftAx, gAy, 3);
	static Shape arrowR = new Polygon(rightAx, gAy, 3);
	private static final long serialVersionUID = 1L;
	
	private BlockModel model;
	double xScale = 200.0;

	/** Creates new form IPView */
	public BlockView() {
		setDoubleBuffered(true);
		setBackground(Color.WHITE);
		initComponents();

	}

	public Component getDisplayPanel() {
		return this;
	}

	BlockModel getModel() {
		return model;
	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	private void initComponents() { //     setLayout(new java.awt.BorderLayout());

	//       setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
	}

	public boolean isHumanActive() {
		throw new UnsupportedOperationException("Not supported yet.");
	}

	/**
	 * call when a state change in the model requires an update to the view
	 */
	public void modelStateChanged() {
		this.repaint();
	}

	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g; // in most cases (ours) this is a safe cast

		// get the dimensions of the JPanel so that we can scale everything properly
		//  Insets insets = getInsets();
		int viewWidth = getWidth();// - insets.left - insets.right;
		int viewHeight = getHeight();// - insets.top - insets.bottom;

		// scale the size of the model to the size of the view.
		// the constants are chosen for asthetics, but could be based on say
		// the masses of  the objects.
		// Note that for the view to be physiclly correct, l and x must be
		// correctly proportianal. ( FIXME - better explaination )

		int blockWidth = 50;
		int blockHeight = 30;
		double modelX = 0;

		//
		if( model != null ) modelX = model.getX();

		int blockX = (int) (modelX * xScale + viewWidth / 2);
		int blockY = viewHeight / 2;
		int fX = 6 * (int) model.getForce();

		// paint the block
		g2.setColor(Color.blue);
		g2.fill(new Rectangle(blockX - blockWidth / 2, blockY - blockHeight, blockWidth, blockHeight));

		g2.setColor(Color.BLACK);

		if( fX > 0 ) {
			int xx = blockX + blockWidth / 2;
			int yy = blockY - blockHeight / 2;
			g2.drawLine(xx, yy, xx + fX, yy);
			g2.translate(xx + fX, yy);
			g2.fill(arrowR);
			g2.translate(-(xx + fX), -yy);

		} else if( fX < 0 ) {
			int xx = blockX - blockWidth / 2;
			int yy = blockY - blockHeight / 2;
			g2.drawLine(xx, yy, xx + fX, yy);
			g2.translate(xx + fX, yy);
			g2.fill(arrowL);
			g2.translate(-(xx + fX), -yy);

		}
		g2.drawString(model.toString(), 10, getHeight() - 20);
	}

	public void reset() {
	}

	public double screenToWorld(int x) {
		int xOff = getWidth() / 2;
		return (x - xOff) / xScale;
	}

	/**
	 * associate a model with this view
	 */
	public void setModel(Model aModel) {
		model = (BlockModel) aModel;
	}

	public int worldToScreen(double x) {
		int xOff = getWidth() / 2;// - insets.left - insets.right;
		return (int) (xOff + x * xScale);
	}
}
