package net.sourceforge.jFuzzyLogic.ruleConnectionMethod;

/**
 * Base for methods used to connect rule's antecedents
 * 
 * From FCL's specs:
 * 
 * "To fulfill de Morgans Law, the algorithms for operators AND and OR shall be used pair-wise e.g. 
 * MAX shall be used for OR if MIN is used for AND."
 *  
 * 			Operator OR 		Operator AND 
 * 			MAX					MIN 
 * 			ASUM				PROD 
 * 			BSUM				BDIF
 *  
 * @author pcingola@users.sourceforge.net
 */
public abstract class RuleConnectionMethod {

	String name;

	public RuleConnectionMethod() {
		name = "Undefined name! (Please set it up in constructor)";
	}

	public abstract double connect(double antecedent1, double antecedent2);

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public abstract String toStringFCL();
}
