/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fuzzytest;
import java.awt.*;
import javax.swing.*;
import net.sourceforge.jFuzzyLogic.FIS;
import net.sourceforge.jFuzzyLogic.rule.*;
/**
 *
 * @author prashanthk
 */
public class InvertedPendulum extends JFrame
{
    double theta=-24,angVel=-2,shiftedTheta=0;
    double deltaTime=0.5;
    double mass=0.01,g=9.8,r=1;
    double curr=0.0;
    double damping = 0.0;
    double motorConst=0.02;
    String fclFile="F:/Documents and Settings/prashanthk/My Documents/NetBeansProjects/FuzzyTest/src/fuzzytest/invPend.fcl"; 
    FIS fis;
    boolean stop=false;
    
    public InvertedPendulum(double theta, double angVel, double deltaTime, double mass, double damping, double radius, double motorConst, String fclFile)
    {
            
        this.theta=theta;
        this.angVel=angVel;
        this.deltaTime=deltaTime;
        this.mass=mass;
        this.damping=damping;
        this.r=radius;
        this.motorConst=motorConst;
        this.fclFile = fclFile;
        
        fis = FIS.load(fclFile,true);
    // Error while loading?
         if( fis == null ) 
         { 
             System.err.println("Can't load file: '"  + fclFile + "'");
             return;
         }
         //fis.chart();
         System.out.println("Hi");
         setSize(500,500);
         setVisible(true);
         setDefaultCloseOperation(EXIT_ON_CLOSE);

           
    }
    
    public void stop()
    {
        if(stop)
            stop=false;
        else
            stop=true;
    }
    
    public void evaluateCurrent()
    {
        double angle=theta;
//        while(theta<-360||theta>360)
//        {
//            if(theta>360)
//                theta=theta-360;
//            if(theta<-360)
//                theta=-(theta+360);
//            if(angle>180)
//            {
//                theta=theta-360;
//            }
//        }
        theta=Math.IEEEremainder(theta, 360);
        
        if(theta>180)
            theta=theta-360;
            
        double thetaRad=theta;//angle;//*Math.PI/180;
        fis.setVariable("theta", thetaRad);
        fis.setVariable("omega", angVel);
        
        fis.evaluate();
        curr=fis.getVariable("current").defuzzify();
    }
    
    public double getMotorTorque()
    {
            evaluateCurrent();
            System.out.println("Theta:" + theta + " Omega:"+angVel+" Current:"+curr);
            return curr*motorConst;
    }
    public double getGravTorque()
    {
            
            //double thetaRad=theta*Math.PI/180;
            
            return mass*g*Math.sin(theta*Math.PI/180)*r*r;//100=r**2
    }
    public double getTorque()
    {
            return getGravTorque()+getMotorTorque();
    }
    public double getMI()
    {
            return mass*r*r;
    }
    public void paint(Graphics g)
    {
            super.paint(g);
            Graphics2D g2=(Graphics2D)g;

            //Rectangle
            g2.drawRect(250,250,10,10);

            //Line
            double temp=theta;
            double x2,y2;
            x2=255+100*Math.cos(theta*Math.PI/180);
            y2=255+100*Math.sin(theta*Math.PI/180);
            g2.drawLine(255,255,(int)(x2),(int)(y2));
            while(true)
            {
                    g2.setColor(g2.getBackground());
                    x2=255+100*Math.cos(temp*Math.PI/180);
                    y2=255+100*Math.sin(temp*Math.PI/180);
                    g2.drawLine(255,255,(int)(x2),(int)(y2));
                    g2.drawOval((int)(x2)-10,(int)(y2)-10,20,20);

                    angVel=(angVel+(getTorque()/getMI())*deltaTime)*(1-damping);
                    theta=theta+(angVel)*deltaTime;
                    shiftedTheta=theta-90;

                    temp=shiftedTheta;


                    g2.setColor(Color.BLACK);
                    x2=255+100*Math.cos(shiftedTheta*Math.PI/180);
                    y2=255+100*Math.sin(shiftedTheta*Math.PI/180);
                    g2.drawLine(255,255,(int)(x2),(int)(y2));
                    g2.drawOval((int)(x2)-10,(int)(y2)-10,20,20);

                    g2.drawRect(250,250,10,10);

                    try{
                            Thread.sleep(300);
                    }
                    catch(Exception e)
                    {
                            e.printStackTrace();
                    }
            }
    }
    
    

}
