/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sourceforge.jFuzzyLogic.demo;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;

import net.sourceforge.jFuzzyLogic.FIS;
import net.sourceforge.jFuzzyLogic.rule.Variable;

import org.antlr.runtime.RecognitionException;

/**
 *
 * @author pjl
 */
public abstract class FuzzyController {

	//   protected FunctionBlock functionBlock;
	protected FIS fis;
	protected Model model;
	protected Vector<Variable> variables;

	protected FuzzyController(File file, Model model) {
		this.model = model;
		variables = new Vector<Variable>();
		try {
			reload(file);
		} catch(IOException ex) {
			Logger.getLogger(FuzzyController.class.getName()).log(Level.SEVERE, null, ex);
		}
	}

	abstract public void control();

	public FIS getFis() {
		return fis;
	}

	public Model getModel() {
		return model;
	}

	//    public String showState() {
	//        
	//        
	//        String str=functionBlock.toString() +"\n";
	//        return str += util.Debugger.functionBlockToString(functionBlock);
	//    }

	abstract public List<Variable> getVariables();

	abstract protected void init();

	//    public FunctionBlock getFuzzyRuleSet() {
	//        return functionBlock;
	//    }

	public void reload(File file) throws IOException {

		FIS newfis = FIS.load(file.getPath(), true);
		if( newfis == null ) { // Error while loading?
			System.err.println("Can't load file: '" + file + "'");
			return;
		}
		fis = newfis;
		// functionBlock = fis.getFunctionBlock(null);
		init();
	}

	public void reload(String str) {
		FIS newfis;
		try {
			newfis = FIS.createFromString(str, true);
			fis = newfis;
			//          functionBlock = fis.getFunctionBlock(null);
			init();
		} catch(RecognitionException ex) {
			Logger.getLogger(FuzzyController.class.getName()).log(Level.SEVERE, null, ex);
		}

	}

	abstract public String showState();

}
